GFP2_ONB< F > Class Template Reference

GF(p^2), optimal normal basis. More...

`#include <xtr.h>`

Inheritance diagram for GFP2_ONB< F >:

## Public Types

typedef F | BaseField
Public Types inherited from AbstractRing< GFP2Element >
typedef GFP2Element | Element
Public Types inherited from AbstractGroup< GFP2Element >
typedef GFP2Element | Element

## Public Member Functions

| GFP2_ONB (const Integer &p)
const Integer & | GetModulus () const
GFP2Element | ConvertIn (const Integer &a) const
GFP2Element | ConvertIn (const GFP2Element &a) const
GFP2Element | ConvertOut (const GFP2Element &a) const
bool | Equal (const GFP2Element &a, const GFP2Element &b) const
| Compare two elements for equality.
const Element & | Identity () const
| Provides the Identity element.
const Element & | Add (const Element &a, const Element &b) const
| Adds elements in the group.
const Element & | Inverse (const Element &a) const
| Inverts the element in the group.
const Element & | Double (const Element &a) const
| Doubles an element in the group.
const Element & | Subtract (const Element &a, const Element &b) const
| Subtracts elements in the group.
Element & | Accumulate (Element &a, const Element &b) const
| TODO.
Element & | Reduce (Element &a, const Element &b) const
| Reduces an element in the congruence class.
bool | IsUnit (const Element &a) const
| Determines whether an element is a unit in the group.
const Element & | MultiplicativeIdentity () const
| Retrieves the multiplicative identity.
const Element & | Multiply (const Element &a, const Element &b) const
| Multiplies elements in the group.
const Element & | MultiplicativeInverse (const Element &a) const
| Calculate the multiplicative inverse of an element in the group.
const Element & | Square (const Element &a) const
| Square an element in the group.
Element | Exponentiate (const Element &a, const Integer &e) const
| Raises a base to an exponent in the group.
const Element & | PthPower (const Element &a) const
void | RaiseToPthPower (Element &a) const
const Element & | SpecialOperation1 (const Element &a) const
const Element & | SpecialOperation2 (const Element &x, const Element &y, const Element &z) const
Public Member Functions inherited from AbstractRing< GFP2Element >
| AbstractRing ()
| Construct an AbstractRing.
AbstractRing & | operator= (const AbstractRing &source)
| Assign an AbstractRing.
virtual const Element & | Divide (const Element &a, const Element &b) const
| Divides elements in the group.
virtual Element | CascadeExponentiate (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO.
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Exponentiates a base to multiple exponents in the Ring.
virtual const AbstractGroup< GFP2Element > & | MultiplicativeGroup () const
| Retrieves the multiplicative group.
Public Member Functions inherited from AbstractGroup< GFP2Element >
virtual bool | InversionIsFast () const
| Determine if inversion is fast.
virtual Element | ScalarMultiply (const Element &a, const Integer &e) const
| Performs a scalar multiplication.
virtual Element | CascadeScalarMultiply (const Element &x, const Integer &e1, const Element &y, const Integer &e2) const
| TODO.
virtual void | SimultaneousMultiply (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
| Multiplies a base to multiple exponents in a group.

## Detailed Description

template<class F>
class GFP2_ONB< F >

GF(p^2), optimal normal basis.

Definition at line 46 of file xtr.h.

## Member Typedef Documentation

## BaseField

template<class F>

typedef F GFP2_ONB< F >::BaseField

Definition at line 49 of file xtr.h.

## Constructor & Destructor Documentation

## GFP2_ONB()

template<class F>

GFP2_ONB< F >::GFP2_ONB | ( | const Integer & | p | ) |

inline

Definition at line 51 of file xtr.h.

## Member Function Documentation

## GetModulus()

template<class F>

const Integer & GFP2_ONB< F >::GetModulus | ( |  | ) | const

inline

Definition at line 57 of file xtr.h.

## ConvertIn() [1/2]

template<class F>

GFP2Element GFP2_ONB< F >::ConvertIn | ( | const Integer & | a | ) | const

inline

Definition at line 59 of file xtr.h.

## ConvertIn() [2/2]

template<class F>

GFP2Element GFP2_ONB< F >::ConvertIn | ( | const GFP2Element & | a | ) | const

inline

Definition at line 65 of file xtr.h.

## ConvertOut()

template<class F>

GFP2Element GFP2_ONB< F >::ConvertOut | ( | const GFP2Element & | a | ) | const

inline

Definition at line 68 of file xtr.h.

## Equal()

template<class F>

bool GFP2_ONB< F >::Equal | ( | const GFP2Element & | a,
|  | const GFP2Element & | b ) const

inline virtual

Compare two elements for equality.

Parameters

  a | first element
  b | second element

Returns
  true if the elements are equal, false otherwise

Equal() tests the elements for equality using a==b

Implements AbstractGroup< GFP2Element >.

Definition at line 71 of file xtr.h.

## Identity()

template<class F>

const Element & GFP2_ONB< F >::Identity | ( |  | ) | const

inline virtual

Provides the Identity element.

Returns
  the Identity element

Implements AbstractGroup< GFP2Element >.

Definition at line 76 of file xtr.h.

## Add()

template<class F>

const Element & GFP2_ONB< F >::Add | ( | const Element & | a,
|  | const Element & | b ) const

inline virtual

Adds elements in the group.

Parameters

  a | first element
  b | second element

Returns
  the sum of a and b

Implements AbstractGroup< GFP2Element >.

Definition at line 81 of file xtr.h.

## Inverse()

template<class F>

const Element & GFP2_ONB< F >::Inverse | ( | const Element & | a | ) | const

inline virtual

Inverts the element in the group.

Parameters

  a | first element

Returns
  the inverse of the element

Implements AbstractGroup< GFP2Element >.

Definition at line 88 of file xtr.h.

## Double()

template<class F>

const Element & GFP2_ONB< F >::Double | ( | const Element & | a | ) | const

inline virtual

Doubles an element in the group.

Parameters

  a | the element

Returns
  the element doubled

Reimplemented from AbstractGroup< GFP2Element >.

Definition at line 95 of file xtr.h.

## Subtract()

template<class F>

const Element & GFP2_ONB< F >::Subtract | ( | const Element & | a,
|  | const Element & | b ) const

inline virtual

Subtracts elements in the group.

Parameters

  a | first element
  b | second element

Returns
  the difference of a and b. The element a must provide a Subtract member function.

Reimplemented from AbstractGroup< GFP2Element >.

Definition at line 102 of file xtr.h.

## Accumulate()

template<class F>

Element & GFP2_ONB< F >::Accumulate | ( | Element & | a,
|  | const Element & | b ) const

inline virtual

TODO.

Parameters

  a | first element
  b | second element

Returns
  TODO

Reimplemented from AbstractGroup< GFP2Element >.

Definition at line 109 of file xtr.h.

## Reduce()

template<class F>

Element & GFP2_ONB< F >::Reduce | ( | Element & | a,
|  | const Element & | b ) const

inline virtual

Reduces an element in the congruence class.

Parameters

  a | element to reduce
  b | the congruence class

Returns
  the reduced element

Reimplemented from AbstractGroup< GFP2Element >.

Definition at line 116 of file xtr.h.

## IsUnit()

template<class F>

bool GFP2_ONB< F >::IsUnit | ( | const Element & | a | ) | const

inline virtual

Determines whether an element is a unit in the group.

Parameters

  a | the element

Returns
  true if the element is a unit after reduction, false otherwise.

Implements AbstractRing< GFP2Element >.

Definition at line 123 of file xtr.h.

## MultiplicativeIdentity()

template<class F>

const Element & GFP2_ONB< F >::MultiplicativeIdentity | ( |  | ) | const

inline virtual

Retrieves the multiplicative identity.

Returns
  the multiplicative identity

Implements AbstractRing< GFP2Element >.

Definition at line 128 of file xtr.h.

## Multiply()

template<class F>

const Element & GFP2_ONB< F >::Multiply | ( | const Element & | a,
|  | const Element & | b ) const

inline virtual

Multiplies elements in the group.

Parameters

  a | the multiplicand
  b | the multiplier

Returns
  the product of a and b

Implements AbstractRing< GFP2Element >.

Definition at line 134 of file xtr.h.

## MultiplicativeInverse()

template<class F>

const Element & GFP2_ONB< F >::MultiplicativeInverse | ( | const Element & | a | ) | const

inline virtual

Calculate the multiplicative inverse of an element in the group.

Parameters

  a | the element

Implements AbstractRing< GFP2Element >.

Definition at line 148 of file xtr.h.

## Square()

template<class F>

const Element & GFP2_ONB< F >::Square | ( | const Element & | a | ) | const

inline virtual

Square an element in the group.

Parameters

  a | the element

Returns
  the element squared

Reimplemented from AbstractRing< GFP2Element >.

Definition at line 153 of file xtr.h.

## Exponentiate()

template<class F>

Element GFP2_ONB< F >::Exponentiate | ( | const Element & | a,
|  | const Integer & | e ) const

inline virtual

Raises a base to an exponent in the group.

Parameters

  a | the base
  e | the exponent

Returns
  the exponentiation

Reimplemented from AbstractRing< GFP2Element >.

Definition at line 161 of file xtr.h.

## PthPower()

template<class F>

const Element & GFP2_ONB< F >::PthPower | ( | const Element & | a | ) | const

inline

Definition at line 169 of file xtr.h.

## RaiseToPthPower()

template<class F>

void GFP2_ONB< F >::RaiseToPthPower | ( | Element & | a | ) | const

inline

Definition at line 176 of file xtr.h.

## SpecialOperation1()

template<class F>

const Element & GFP2_ONB< F >::SpecialOperation1 | ( | const Element & | a | ) | const

inline

Definition at line 182 of file xtr.h.

## SpecialOperation2()

template<class F>

const Element & GFP2_ONB< F >::SpecialOperation2 | ( | const Element & | x,
|  | const Element & | y,
|  | const Element & | z ) const

inline

Definition at line 194 of file xtr.h.

The documentation for this class was generated from the following file:

- xtr.h